import createDecorator from '@loafer/core/util/decorators/createDecorator';

import ConfigurationDefinition from '@loafer/context/definition/ConfigurationDefinition';
import PouchConfig from '@loafer/context/decorator/PouchConfig';

import { getInjectableDefinition } from '@loafer/pouches/util/metadata';
import { InjectableSterotype } from '@loafer/pouches/constants';

const Pouch = (pouchConfig: PouchConfig = {}) => createDecorator('Pouch', {
  methodDecorator: (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
    let configurationDefinition: ConfigurationDefinition = getInjectableDefinition(target, ConfigurationDefinition, false);
    if (undefined === configurationDefinition || InjectableSterotype.CONFIGURATION !== configurationDefinition.Stereotype) {
      throw new Error('Cannot apply @Pouch decorator on not @Configuration class.');
    }
    configurationDefinition.addPouch(propertyKey, pouchConfig);
    return descriptor;
  },
});

export default Pouch;
