import createDecorator from '@loafer/core/util/decorators/createDecorator';
import InjectableDefinition from '@loafer/pouches/definition/InjectableDefinition';
import { getInjectableDefinition } from '@loafer/pouches/util/metadata';

const PostConstruct = createDecorator('PostConstruct', {
  methodDecorator: (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
    let injectableDefinition = getInjectableDefinition(target, InjectableDefinition, false);
    if (undefined === injectableDefinition) {
      throw new Error('Cannot apply @PostConstruct decorator on the not @Injectable or @Injectable stereotype class.');
    }
    injectableDefinition.addPostConstruct(propertyKey);
    return descriptor;
  },
});

export default PostConstruct;
